package org.jeecg.modules.ItdmWtkehu.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.hutool.core.util.ObjectUtil;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.ItdmWtkehu.entity.ItdmWtkehu;
import org.jeecg.modules.ItdmWtkehu.service.IItdmWtkehuService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 客户管理
 * @Author: jeecg-boot
 * @Date:   2023-05-22
 * @Version: V1.0
 */
@Api(tags="客户管理")
@RestController
@RequestMapping("/ItdmWtkehu/itdmWtkehu")
@Slf4j
public class ItdmWtkehuController extends JeecgController<ItdmWtkehu, IItdmWtkehuService> {
	@Autowired
	private IItdmWtkehuService itdmWtkehuService;

	 /**
	  * 下拉列表（有id——非实际id，委托单位，委托地址）
	  * */
	 @ApiOperation("下拉列表（有id——非实际id，委托单位，委托地址")
	 @GetMapping(value = "/xialalist")
	 public List<ItdmWtkehu> xlItdmWtkehuList(){
	 	return itdmWtkehuService.xlItdmWtkehuList();
	 }

	/**
	 * 分页列表查询
	 *
	 * @param itdmWtkehu
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "客户管理-分页列表查询")
	@ApiOperation(value="客户管理-分页列表查询", notes="客户管理-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<ItdmWtkehu>> queryPageList(ItdmWtkehu itdmWtkehu,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		ItdmWtkehu itdmWtkehu1 = new ItdmWtkehu();
		QueryWrapper<ItdmWtkehu> queryWrapper = QueryGenerator.newInitQueryWrapper(itdmWtkehu1, req.getParameterMap());
		queryWrapper.lambda().like(StringUtils.isNoneBlank(itdmWtkehu.getWeituiClient()),ItdmWtkehu::getWeituiClient,itdmWtkehu.getWeituiClient());
		queryWrapper.lambda().like(StringUtils.isNoneBlank(itdmWtkehu.getWeituiLxr()),ItdmWtkehu::getWeituiLxr,itdmWtkehu.getWeituiLxr());
		queryWrapper.lambda().like(StringUtils.isNoneBlank(itdmWtkehu.getWeituiPhone()),ItdmWtkehu::getWeituiPhone,itdmWtkehu.getWeituiPhone());
		queryWrapper.lambda().orderBy(true,false,ItdmWtkehu::getWeituiClient);
		Page<ItdmWtkehu> page = new Page<ItdmWtkehu>(pageNo, pageSize);
		IPage<ItdmWtkehu> pageList = itdmWtkehuService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	 @GetMapping(value = "/olist")
	 public Result<List<ItdmWtkehu>> getAllItdmWtkehues() {
		 List<ItdmWtkehu> list = itdmWtkehuService.list();
		 return Result.OK(list);
	 }

	/**
	 *   添加
	 *
	 * @param itdmWtkehu
	 * @return
	 */
	@AutoLog(value = "客户管理-添加")
	@ApiOperation(value="客户管理-添加", notes="客户管理-添加")
	//@RequiresPermissions("org.jeecg.modules:itdm_wtkehu:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody ItdmWtkehu itdmWtkehu) {
		//ItdmWtkehu queryResult = itdmWtkehuService.getOne(new QueryWrapper<ItdmWtkehu>().eq("weitui_client", itdmWtkehu.getWeituiClient()));
		//if (queryResult != null) {
		//	return Result.error("添加失败，委托单位名称已存在！");
		//}
		itdmWtkehuService.save(itdmWtkehu);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param itdmWtkehu
	 * @return
	 */
	@AutoLog(value = "客户管理-编辑")
	@ApiOperation(value="客户管理-编辑", notes="客户管理-编辑")
	//@RequiresPermissions("org.jeecg.modules:itdm_wtkehu:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
	public Result<String> edit(@RequestBody ItdmWtkehu itdmWtkehu) {
		//ItdmWtkehu queryResult = itdmWtkehuService.getOne(
		//		new QueryWrapper<ItdmWtkehu>()
		//				.eq("weitui_client", itdmWtkehu.getWeituiClient())
		//				.ne("id", itdmWtkehu.getId()) // 排除当前 id
		//);
		//if (queryResult != null) {
		//	return Result.error("编辑失败，委托单位名称已存在！");
		//}
		itdmWtkehuService.updateById(itdmWtkehu);
		return Result.OK("编辑成功！");
	}
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "客户管理-通过id删除")
	@ApiOperation(value="客户管理-通过id删除", notes="客户管理-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:itdm_wtkehu:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		itdmWtkehuService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "客户管理-批量删除")
	@ApiOperation(value="客户管理-批量删除", notes="客户管理-批量删除")
	//@RequiresPermissions("org.jeecg.modules:itdm_wtkehu:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.itdmWtkehuService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "客户管理-通过id查询")
	@ApiOperation(value="客户管理-通过id查询", notes="客户管理-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<ItdmWtkehu> queryById(@RequestParam(name="id",required=true) String id) {
		ItdmWtkehu itdmWtkehu = itdmWtkehuService.getById(id);
		if(itdmWtkehu==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(itdmWtkehu);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param itdmWtkehu
    */
    //@RequiresPermissions("org.jeecg.modules:itdm_wtkehu:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, ItdmWtkehu itdmWtkehu) {
        return super.exportXls(request, itdmWtkehu, ItdmWtkehu.class, "客户管理");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("itdm_wtkehu:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, ItdmWtkehu.class);
    }

}
